import type { User } from 'discord.js';
import type { Item } from './items';

export interface Behavior {
  name: string,
  description: string,
  itemType: 'plain' | 'weapon' | 'consumable',
  // triggers upon use
  // for 'weapons', this is on hit
  // for 'consumable', this is on use
  // for 'plain', ...??
  // returns `true` upon success, `false` otherwise
  action?: (item: Item, user: User) => Promise<boolean>
}

export const behaviors: Behavior[] = [
  {
    name: 'heal',
    description: 'Heals the user by `behaviorValue`',
    itemType: 'consumable',
    action: async (item, user) => {
      // todo
      return false;
    }
  }
];